'
' ClearLNK by Alex Dragokas ver.1.0
' 
'      (.LNK)
'
' : 
'  -  1)         
'  -  2)       CheckBrowserLNK
'  -  3)          
'  (        ,      )
'

Option Explicit

Dim oShellApp: Set oShellApp = CreateObject("Shell.Application")
Dim oShell:    Set oShell    = CreateObject("WScript.Shell")
Dim oFSO:      Set oFSO      = CreateObject("Scripting.FileSystemObject")
Dim LNK, arg
Dim ver: ver = "1.0"
Dim cur

cur = oFSO.GetParentFolderName(WScript.ScriptFullName)

If WScript.Arguments.Count > 0 then 
	arg = WScript.Arguments(0)
	if not CureObject(arg) then msgbox "     !": WScript.Quit 1
else
	arg = inputbox("    ","ClearLNK ver." & ver,cur & "\")
	if arg = "" then WScript.Quit
	LNK = FindLNK(arg)
	if LNK = "" then msgbox "     !": WScript.Quit 1
	call CureObject(LNK)
end if

msgbox ".", vbInformation, "ClearLNK ver." & ver

Function CureObject(file)
	CureObject = true
	Select Case CheckValidExtension(file)
	Case ""
		CureObject = false
	Case "LNK"
		call FixLNK(file)
	Case "URL"
		call FixURL(file)
	Case "LOG"
		call ParseLOG(file)
	End Select
End Function

Function FixLNK(file)
	on error resume next
	with oShell
		with .CreateShortcut(file)
			Dim LNK_Descr:  LNK_Descr  = .Description
			Dim LNK_Key:    LNK_Key    = .HotKey
			Dim LNK_Icon:   LNK_Icon   = .IconLocation
			Dim LNK_Targ:   LNK_Targ   = .TargetPath
			Dim LNK_Style:  LNK_Style  = .WindowStyle
			Dim LNK_WDir:   LNK_WDir   = .WorkingDirectory
			if Err <> 0 then call Elevate()
		end with

		oFSO.DeleteFile file, true
		if Err <> 0 then call Elevate()

		with .CreateShortcut(file)
			.Description        = LNK_Descr
			.HotKey             = LNK_Key
			.IconLocation       = LNK_Icon
			.TargetPath         = LNK_Targ
			.WindowStyle        = LNK_Style
			.WorkingDirectory   = LNK_WDir
			.Save()
			if Err <> 0 then call Elevate()
		end with
	end with
End Function

Function FixURL(file)
	on error resume next
	with oShell
		with .CreateShortcut(file)
			Dim URL_Targ:   URL_Targ   = .TargetPath
			if Err <> 0 then call Elevate()
		end with

		oFSO.DeleteFile file, true
		if Err <> 0 then call Elevate()

		with .CreateShortcut(file)
			.TargetPath   = URL_Targ
			.Save()
			if Err <> 0 then call Elevate()
		end with
	end with
End Function

Function ParseLOG(file)
	Dim arr:	arr = ReadFileToArray(file, "UTF-16LE", "windows-1251")
	Dim Line, LinksBegin
	LinksBegin = false
	For each Line in arr
		if LinksBegin then
			if left(Line, 3) = "===" then Exit Function
			call ParseLogLine(Line)
		end if
		if instr(1, Line, "[ Browser with parameters ]", 1) <> 0 then LinksBegin = true
	Next
End Function

Function ParseLogLine(Line)
	dim pos, file
	pos = 1
	Do
		pos = instr(pos, Line, "[")
		if pos <> 0 then 
			file = trim(left(Line, pos - 1))
			if oFSO.FileExists(file) then
				call CureObject(file) '   (main -> CureObject -> ParseLOG -> ParseLogLine -> CureObject)
				Exit Do
			end if
		end if
		pos = pos + 1
	Loop while pos
End function

Function FindLNK(file) ' LNK, URL  LOG,      
	Dim Ext
	For each Ext in Array("", ".LNK", ".LOG") '".URL"
		if oFSO.FileExists(file & Ext) then FindLNK = file & Ext: Exit For
	Next
End Function

Function CheckValidExtension(file)
	Dim Ext
	if not oFSO.FileExists(file) then Exit Function
	For each Ext in Array("LNK", "LOG") '"URL"
		if UCase(oFSO.GetExtensionName(file)) = Ext then CheckValidExtension = Ext: Exit For
	Next	
End Function

Sub Elevate()
    if msgbox("  ." & vblf & " ClearLNK    ?",vbQuestion+vbYesNo,"") = vbNo then WScript.Quit 5    
    oShellApp.ShellExecute WScript.FullName, """" & WScript.ScriptFullName & """" & " " & """" & LNK & """", "", "runas", 1
	WScript.Quit 0
End Sub

Function ReadFileToArray(file, srcEncode, destEncode)
	Dim Text
    With CreateObject("ADODB.Stream")
		.Type = 2
		.Charset = srcEncode
        .Open
		.LoadFromFile file
		if .Size = 0 then WScript.Quit 2
		Text = .ReadText()
		.Close
		.Charset = destEncode
		.Open
		.WriteText (Text)
		.Position = 0
		Text = .ReadText()
		.Close
	end with
	ReadFileToArray = Split(Text, vbCrLf)
End Function
